/* jshint undef: true, unused: true */
/* global module, java */

var JDate = java.util.Date;

var DATE_FORMAT = new java.text.SimpleDateFormat("MM/dd/yyyy");
var TIME_FORMAT = new java.text.SimpleDateFormat("hh:mm aa");
var DATE_TIME_FORMAT = new java.text.SimpleDateFormat("MM/dd/yyyy hh:mm aa");

var HOURS = java.time.temporal.ChronoUnit.HOURS;
function parseStartTimeParameters (startDate, startTime)
{    
    return DATE_TIME_FORMAT.parse(startDate + " " + startTime).getTime();
}

function parseDurationParameter (value)
{
    var parts = value.split(":");
    return 60 * parseInt(parts[0]) + parseInt(parts[1]);
}

function formatDurationMinutes (value)
{
    var hours = parseInt(value / 60);
    var minutes = value % 60;
    return hours + ":" + minutes;
}

function getNextHourOfToday ()
{
    return JDate.from(
        java.time.Instant.now().plus(1, HOURS).truncatedTo(HOURS)
    );
}

function now ()
{
    return new JDate();
}

module.exports = {
    DATE_FORMAT: DATE_FORMAT,
    TIME_FORMAT: TIME_FORMAT,
    now: now,
    parseStartTimeParameters: parseStartTimeParameters,
    parseDurationParameter: parseDurationParameter,
    formatDurationMinutes: formatDurationMinutes,
    getNextHourOfToday: getNextHourOfToday
};