var _ = require("lodash");

var observablePlugin = require("./plugins").observablePlugin;
var notify = require("./components/notify");

var plugin = observablePlugin("schedule-form-plugin");

/*
 * Hook into the plugin object with our specific data and methods
 */
plugin().extend({
    form: ko.observable(),
    
    /*
     * Actually submit the settings back to the plugin.
     */
    submit: function submit ()
    {
        plugin().settings(ko.mapping.toJS(plugin().form())).then(function () {
            notify.success("Custom Schedule Form settings saved successfully.");
        });
    }
});

/*
 * UI hook for settings panel
 */
addSettingsPanel({
    link: {
        icon: "icon-calendar",
        text: "Custom Schedule Form",
        link: "#settings-custom-schedule-form",
        after: "#settings-nav-scheduler + li + li"
    },
    panel: this.templates.settingsPanel
});

/*
 * Wrap the settings received from the plugin into knockout observables,
 * so we can bind them to our form.
 */
addEventListener("INIT", function () {
    if (!CatturaBox.user().can("manage settings"))
    {
        return;
    }
    
    plugin().settings().then(function (settings) {
        plugin().form(ko.mapping.fromJS(settings));
    });
});